Index: DCWoRMS/branches/coolemall/src/example/localplugin/Cluster_FCFSBF_ConsolidationHighPerf_NodePowMan_Plugin.java
===================================================================
--- DCWoRMS/branches/coolemall/src/example/localplugin/Cluster_FCFSBF_ConsolidationHighPerf_NodePowMan_Plugin.java	(revision 1299)
+++ DCWoRMS/branches/coolemall/src/example/localplugin/Cluster_FCFSBF_ConsolidationHighPerf_NodePowMan_Plugin.java	(revision 1299)
@@ -0,0 +1,252 @@
+package example.localplugin;
+
+import gridsim.dcworms.DCWormsTags;
+
+import java.util.ArrayList;
+import java.util.Collections;
+import java.util.Comparator;
+import java.util.HashMap;
+import java.util.List;
+import java.util.Map;
+
+import schedframe.events.scheduling.SchedulingEvent;
+import schedframe.exceptions.ResourceException;
+import schedframe.resources.ResourceStatus;
+import schedframe.resources.StandardResourceType;
+import schedframe.resources.computing.ComputingResource;
+import schedframe.resources.computing.Node;
+import schedframe.resources.computing.Processor;
+import schedframe.resources.computing.profiles.energy.airthroughput.StandardAirThroughputStateName;
+import schedframe.resources.computing.profiles.energy.power.PState;
+import schedframe.resources.computing.profiles.energy.power.StandardPowerStateName;
+import schedframe.resources.devices.Device;
+import schedframe.resources.units.ProcessingElements;
+import schedframe.resources.units.ResourceUnit;
+import schedframe.resources.units.ResourceUnitName;
+import schedframe.resources.units.StandardResourceUnitName;
+import schedframe.scheduling.manager.resources.ClusterResourceManager;
+import schedframe.scheduling.manager.resources.ResourceManager;
+import schedframe.scheduling.manager.tasks.JobRegistry;
+import schedframe.scheduling.plan.SchedulingPlanInterface;
+import schedframe.scheduling.plan.impl.SchedulingPlan;
+import schedframe.scheduling.plugin.grid.ModuleList;
+import schedframe.scheduling.queue.TaskQueue;
+import schedframe.scheduling.queue.TaskQueueList;
+import schedframe.scheduling.tasks.TaskInterface;
+
+public class Cluster_FCFSBF_ConsolidationHighPerf_NodePowMan_Plugin extends BaseLocalSchedulingPlugin {
+
+	public Cluster_FCFSBF_ConsolidationHighPerf_NodePowMan_Plugin () {
+	}
+
+	public SchedulingPlanInterface<?> schedule(SchedulingEvent event, TaskQueueList queues, JobRegistry jobRegistry,
+			ResourceManager resManager, ModuleList modules) {
+
+		ClusterResourceManager resourceManager = (ClusterResourceManager) resManager;
+		SchedulingPlan plan = new SchedulingPlan();
+		// choose the events types to serve.
+		// Different actions for different events are possible.
+		switch (event.getType()) {
+		case START_TASK_EXECUTION:
+		case TASK_FINISHED:
+			// our tasks are placed only in first queue (see
+			// BaseLocalSchedulingPlugin.placeJobsInQueues() method)
+			TaskQueue q = queues.get(0);
+			// check all tasks in queue
+
+			List<Node> notSelectedNodes = resourceManager.getNodes();
+			
+			for (int i = 0; i < q.size(); i++) {
+				TaskInterface<?> task = q.get(i);
+				// if status of the tasks in READY
+				if (task.getStatus() == DCWormsTags.READY) {
+
+					Map<ResourceUnitName, ResourceUnit> choosenResources =  chooseResourcesForExecution(resourceManager, task);
+					if (choosenResources  != null) {
+						addToSchedulingPlan(plan, task, choosenResources);
+						ProcessingElements pe = (ProcessingElements) choosenResources.get(StandardResourceUnitName.PE);
+						Node node = (Node) pe.get(0).getParent();
+						notSelectedNodes.remove(node);
+					} 
+				}
+			}
+			turnOffIdleNodes(notSelectedNodes);
+			break;
+		}
+		return plan;
+	}
+	
+	@SuppressWarnings("unchecked")
+	private Map<ResourceUnitName, ResourceUnit> chooseResourcesForExecution(ClusterResourceManager resourceManager, TaskInterface<?> task){
+
+		List<Node> nodes = resourceManager.getNodes();
+		List<Node> availableNodes = findSuitableNodes(task, nodes);
+		Node node;
+		if(availableNodes.size() == 0){
+			try {
+				nodes = (List<Node>) resourceManager.getResourcesByTypeWithStatus(StandardResourceType.Node, ResourceStatus.UNAVAILABLE);
+			} catch (ResourceException e) {
+				// TODO Auto-generated catch block
+				e.printStackTrace();
+			}
+			Collections.sort(nodes, new PerformanceComparator());
+			node = turnOnFirstNode(nodes, task);
+			if(node == null)
+				return null;
+		}else{
+			Collections.sort(availableNodes, new PerformanceComparator());
+			node = availableNodes.get(0);
+		} 
+		Map<ResourceUnitName, ResourceUnit> map = new HashMap<ResourceUnitName, ResourceUnit>();
+		List<ComputingResource> choosenResources =  new ArrayList<ComputingResource>();
+		int cpuRequest;
+		try {
+			cpuRequest = Double.valueOf(task.getCpuCntRequest()).intValue();
+		} catch (NoSuchFieldException e) {
+			cpuRequest = 0;
+		}
+		for (int i = 0; i < node.getProcessors().size() && cpuRequest > 0; i++) {
+			if (node.getProcessors().get(i).getStatus() == ResourceStatus.FREE) {
+				choosenResources.add(node.getProcessors().get(i));
+				cpuRequest--;
+			}
+		}
+		ProcessingElements result = new ProcessingElements(node.getFullName());
+		result.addAll(choosenResources);
+		map.put(StandardResourceUnitName.PE, result);
+		return map;
+	}
+	
+	private List<Node> findSuitableNodes(TaskInterface<?> task, List<Node> nodes) {
+		int cpuRequest;
+		try {
+			cpuRequest = Double.valueOf(task.getCpuCntRequest()).intValue();
+		} catch (NoSuchFieldException e) {
+			cpuRequest = 1;
+		}
+
+		List<Node> suitableNodes = new ArrayList<Node>();
+		for(Node node: nodes){
+			if(node.getFreeProcessorsNumber() >= cpuRequest){
+				suitableNodes.add(node);
+			}	
+
+		}
+		return suitableNodes;
+	}
+	
+	private Node turnOnFirstNode(List<Node> nodes, TaskInterface<?> task){
+		Node startedNode = null;
+
+		int cpuRequest;
+		try {
+			cpuRequest = Double.valueOf(task.getCpuCntRequest()).intValue();
+		} catch (NoSuchFieldException e) {
+			cpuRequest = 0;
+		}
+		
+		for(Node node: nodes){
+			
+			if (cpuRequest != 0) {
+
+				List<Processor> processors = node.getProcessors();
+				if (processors.size() < cpuRequest) {
+					if(processors.size() == 0){
+						if(node.getProcessors().size() < cpuRequest)
+							continue;
+					}
+				}
+				
+				int freeProcessor = 0;
+				for(Processor processor: processors){
+					if(processor.getStatus() == ResourceStatus.FREE || processor.getStatus() == ResourceStatus.UNAVAILABLE)
+						freeProcessor++;
+				}
+				
+				if(freeProcessor < cpuRequest)
+					continue;
+				else {
+					for(Device device: node.getParent().getResourceCharacteristic().getDevices()){
+						if(device.getType().equals(StandardResourceType.Fan)){
+							device.getAirThroughputInterface().setAirThroughputState(StandardAirThroughputStateName.ON);
+							break;
+						}
+					}
+					node.getPowerInterface().setPowerState(StandardPowerStateName.ON);
+					startedNode = node;
+					break;
+				}				
+			}
+		}
+		return startedNode;
+	}
+	private void turnOffIdleNodes(List<Node> nodes){
+		for(Node node : nodes){
+			int freeProcessors = 0;
+			for(Processor proc: node.getProcessors()){
+				if(proc.getStatus() == ResourceStatus.FREE)
+					freeProcessors++;
+			}
+			
+			if(freeProcessors == node.getProcessors().size()) {
+				for(Device device: node.getParent().getResourceCharacteristic().getDevices()){
+					if(device.getType().equals(StandardResourceType.Fan)){
+						device.getAirThroughputInterface().setAirThroughputState(StandardAirThroughputStateName.OFF);
+						break;
+					}
+				}
+				node.getPowerInterface().setPowerState(StandardPowerStateName.OFF);
+			}
+
+		}
+	}
+	
+	class PerformanceComparator implements Comparator<Node>{
+		
+	    public int compare(Node node1, Node node2){    
+	    	double node1Rank = Double.MIN_VALUE;
+	    	double node2Rank = Double.MIN_VALUE;
+
+	    	double node1Speed = 0;
+	    	for(Processor proc: node1.getProcessors()){
+	    		node1Speed = proc.getMIPS();
+	    	}
+	    	node1Rank = node1Speed / node1.getProcessors().size();
+	    	
+	    	double node2Speed = 0;
+	    	for(Processor proc: node2.getProcessors()){
+	    		node2Speed = proc.getMIPS();
+	    	}
+	    	node2Rank = node2Speed / node2.getProcessors().size();
+	    	
+	    	if(node1Rank == node2Rank){
+	    		node1Rank = Double.MIN_VALUE;
+	    		node2Rank = Double.MIN_VALUE;
+	    		PState pState;
+		    	for(Processor proc: node1.getProcessors()){
+		    		if(proc.getPowerInterface() != null) {
+			    		pState = proc.getPowerInterface().getLowestPState();
+			    		if(pState != null && pState.getFrequency() > node1Rank){
+			    			node1Rank = proc.getPowerInterface().getLowestPState().getFrequency();
+			    		}
+		    		}
+		    	}
+		    	for(Processor proc: node2.getProcessors()){
+		    		if(proc.getPowerInterface() != null) {
+			    		pState = proc.getPowerInterface().getLowestPState();
+			    		if(pState != null && pState.getFrequency() > node2Rank){
+			    			node2Rank = proc.getPowerInterface().getLowestPState().getFrequency();
+			    		}
+		    		}
+		    	}
+	    	}
+	    	
+	        if(node1Rank < node2Rank)
+	        	return 1;
+	        else if (node1Rank > node2Rank)
+	        	return -1;
+	        else return 0;	   
+	    }
+	}
+
+}
Index: DCWoRMS/branches/coolemall/src/example/localplugin/Cluster_FCFSBF_ConsolidationLowPower_NodePowMan_Plugin.java
===================================================================
--- DCWoRMS/branches/coolemall/src/example/localplugin/Cluster_FCFSBF_ConsolidationLowPower_NodePowMan_Plugin.java	(revision 1299)
+++ DCWoRMS/branches/coolemall/src/example/localplugin/Cluster_FCFSBF_ConsolidationLowPower_NodePowMan_Plugin.java	(revision 1299)
@@ -0,0 +1,235 @@
+package example.localplugin;
+
+import gridsim.dcworms.DCWormsTags;
+
+import java.util.ArrayList;
+import java.util.Collections;
+import java.util.Comparator;
+import java.util.HashMap;
+import java.util.List;
+import java.util.Map;
+
+import schedframe.events.scheduling.SchedulingEvent;
+import schedframe.exceptions.ResourceException;
+import schedframe.resources.ResourceStatus;
+import schedframe.resources.StandardResourceType;
+import schedframe.resources.computing.ComputingResource;
+import schedframe.resources.computing.Node;
+import schedframe.resources.computing.Processor;
+import schedframe.resources.computing.profiles.energy.airthroughput.StandardAirThroughputStateName;
+import schedframe.resources.computing.profiles.energy.power.PState;
+import schedframe.resources.computing.profiles.energy.power.StandardPowerStateName;
+import schedframe.resources.devices.Device;
+import schedframe.resources.units.ProcessingElements;
+import schedframe.resources.units.ResourceUnit;
+import schedframe.resources.units.ResourceUnitName;
+import schedframe.resources.units.StandardResourceUnitName;
+import schedframe.scheduling.manager.resources.ClusterResourceManager;
+import schedframe.scheduling.manager.resources.ResourceManager;
+import schedframe.scheduling.manager.tasks.JobRegistry;
+import schedframe.scheduling.plan.SchedulingPlanInterface;
+import schedframe.scheduling.plan.impl.SchedulingPlan;
+import schedframe.scheduling.plugin.grid.ModuleList;
+import schedframe.scheduling.queue.TaskQueue;
+import schedframe.scheduling.queue.TaskQueueList;
+import schedframe.scheduling.tasks.TaskInterface;
+
+public class Cluster_FCFSBF_ConsolidationLowPower_NodePowMan_Plugin extends BaseLocalSchedulingPlugin {
+
+	public Cluster_FCFSBF_ConsolidationLowPower_NodePowMan_Plugin () {
+	}
+
+	public SchedulingPlanInterface<?> schedule(SchedulingEvent event, TaskQueueList queues, JobRegistry jobRegistry,
+			ResourceManager resManager, ModuleList modules) {
+
+		ClusterResourceManager resourceManager = (ClusterResourceManager) resManager;
+		SchedulingPlan plan = new SchedulingPlan();
+		// choose the events types to serve.
+		// Different actions for different events are possible.
+		switch (event.getType()) {
+		case START_TASK_EXECUTION:
+		case TASK_FINISHED:
+			// our tasks are placed only in first queue (see
+			// BaseLocalSchedulingPlugin.placeJobsInQueues() method)
+			TaskQueue q = queues.get(0);
+			// check all tasks in queue
+
+			List<Node> notSelectedNodes = resourceManager.getNodes();
+			
+			for (int i = 0; i < q.size(); i++) {
+				TaskInterface<?> task = q.get(i);
+				// if status of the tasks in READY
+				if (task.getStatus() == DCWormsTags.READY) {
+
+					Map<ResourceUnitName, ResourceUnit> choosenResources =  chooseResourcesForExecution(resourceManager, task);
+					if (choosenResources  != null) {
+						addToSchedulingPlan(plan, task, choosenResources);
+						ProcessingElements pe = (ProcessingElements) choosenResources.get(StandardResourceUnitName.PE);
+						Node node = (Node) pe.get(0).getParent();
+						notSelectedNodes.remove(node);
+					} 
+				}
+			}
+			turnOffIdleNodes(notSelectedNodes);
+			break;
+		}
+		return plan;
+	}
+	
+	private Map<ResourceUnitName, ResourceUnit> chooseResourcesForExecution(ClusterResourceManager resourceManager, TaskInterface<?> task){
+
+		List<Node> nodes = resourceManager.getNodes();
+		List<Node> availableNodes = findSuitableNodes(task, nodes);
+		Node node;
+		if(availableNodes.size() == 0){
+			try {
+				nodes = (List<Node>) resourceManager.getResourcesByTypeWithStatus(StandardResourceType.Node, ResourceStatus.UNAVAILABLE);
+			} catch (ResourceException e) {
+				// TODO Auto-generated catch block
+				e.printStackTrace();
+			}
+			Collections.sort(nodes, new PowerComparator());
+			node = turnOnFirstNode(nodes, task);
+			if(node == null)
+				return null;
+		}else{
+			Collections.sort(availableNodes, new PowerComparator());
+			node = availableNodes.get(0);
+		} 
+		Map<ResourceUnitName, ResourceUnit> map = new HashMap<ResourceUnitName, ResourceUnit>();
+		List<ComputingResource> choosenResources =  new ArrayList<ComputingResource>();
+		int cpuRequest;
+		try {
+			cpuRequest = Double.valueOf(task.getCpuCntRequest()).intValue();
+		} catch (NoSuchFieldException e) {
+			cpuRequest = 0;
+		}
+		for (int i = 0; i < node.getProcessors().size() && cpuRequest > 0; i++) {
+			if (node.getProcessors().get(i).getStatus() == ResourceStatus.FREE) {
+				choosenResources.add(node.getProcessors().get(i));
+				cpuRequest--;
+			}
+		}
+		ProcessingElements result = new ProcessingElements(node.getFullName());
+		result.addAll(choosenResources);
+		map.put(StandardResourceUnitName.PE, result);
+		return map;
+	}
+	
+	private List<Node> findSuitableNodes(TaskInterface<?> task, List<Node> nodes) {
+		int cpuRequest;
+		try {
+			cpuRequest = Double.valueOf(task.getCpuCntRequest()).intValue();
+		} catch (NoSuchFieldException e) {
+			cpuRequest = 1;
+		}
+
+		List<Node> suitableNodes = new ArrayList<Node>();
+		for(Node node: nodes){
+			if(node.getFreeProcessorsNumber() >= cpuRequest){
+				suitableNodes.add(node);
+			}	
+
+		}
+		return suitableNodes;
+	}
+	
+	private Node turnOnFirstNode(List<Node> nodes, TaskInterface<?> task){
+		Node startedNode = null;
+
+		int cpuRequest;
+		try {
+			cpuRequest = Double.valueOf(task.getCpuCntRequest()).intValue();
+		} catch (NoSuchFieldException e) {
+			cpuRequest = 0;
+		}
+		
+		for(Node node: nodes){
+			
+			if (cpuRequest != 0) {
+
+				List<Processor> processors = node.getProcessors();
+				if (processors.size() < cpuRequest) {
+					if(processors.size() == 0){
+						if(node.getProcessors().size() < cpuRequest)
+							continue;
+					}
+				}
+				
+				int freeProcessor = 0;
+				for(Processor processor: processors){
+					if(processor.getStatus() == ResourceStatus.FREE || processor.getStatus() == ResourceStatus.UNAVAILABLE)
+						freeProcessor++;
+				}
+				
+				if(freeProcessor < cpuRequest)
+					continue;
+				else {
+					for(Device device: node.getParent().getResourceCharacteristic().getDevices()){
+						if(device.getType().equals(StandardResourceType.Fan)){
+							device.getAirThroughputInterface().setAirThroughputState(StandardAirThroughputStateName.ON);
+							break;
+						}
+					}
+					node.getPowerInterface().setPowerState(StandardPowerStateName.ON);
+					startedNode = node;
+					break;
+				}				
+			}
+		}
+		return startedNode;
+	}
+	private void turnOffIdleNodes(List<Node> nodes){
+		for(Node node : nodes){
+			int freeProcessors = 0;
+			for(Processor proc: node.getProcessors()){
+				if(proc.getStatus() == ResourceStatus.FREE)
+					freeProcessors++;
+			}
+			
+			if(freeProcessors == node.getProcessors().size()) {
+				for(Device device: node.getParent().getResourceCharacteristic().getDevices()){
+					if(device.getType().equals(StandardResourceType.Fan)){
+						device.getAirThroughputInterface().setAirThroughputState(StandardAirThroughputStateName.OFF);
+						break;
+					}
+				}
+				node.getPowerInterface().setPowerState(StandardPowerStateName.OFF);
+			}
+
+		}
+	}
+	
+	class PowerComparator implements Comparator<Node>{
+		
+	    public int compare(Node node1, Node node2){    
+	    	double node1Rank = Double.MAX_VALUE;
+	    	double node2Rank = Double.MAX_VALUE;
+
+    		PState pState;
+	    	for(Processor proc: node1.getProcessors()){
+	    		if(proc.getPowerInterface() != null) {
+		    		pState = proc.getPowerInterface().getLowestPState();
+		    		if(pState != null && pState.getPower() < node1Rank){
+		    			node1Rank = proc.getPowerInterface().getLowestPState().getFrequency();
+		    		}
+	    		}
+	    	}
+	    	for(Processor proc: node2.getProcessors()){
+	    		if(proc.getPowerInterface() != null) {
+		    		pState = proc.getPowerInterface().getLowestPState();
+		    		if(pState != null && pState.getPower() < node2Rank){
+		    			node2Rank = proc.getPowerInterface().getLowestPState().getFrequency();
+		    		}
+	    		}
+	    	}
+	    	
+	        if(node1Rank > node2Rank)
+	        	return 1;
+	        else if (node1Rank < node2Rank)
+	        	return -1;
+	        else return 0;	   
+	    }
+	}
+
+}
Index: DCWoRMS/branches/coolemall/src/example/localplugin/Cluster_FCFSBF_ExamplePlugin.java
===================================================================
--- DCWoRMS/branches/coolemall/src/example/localplugin/Cluster_FCFSBF_ExamplePlugin.java	(revision 1299)
+++ DCWoRMS/branches/coolemall/src/example/localplugin/Cluster_FCFSBF_ExamplePlugin.java	(revision 1299)
@@ -0,0 +1,155 @@
+package example.localplugin;
+
+import gridsim.dcworms.DCWormsTags;
+
+import java.util.ArrayList;
+import java.util.HashMap;
+import java.util.List;
+import java.util.Map;
+import java.util.Properties;
+
+import schedframe.events.scheduling.SchedulingEvent;
+import schedframe.resources.ResourceStatus;
+import schedframe.resources.StandardResourceType;
+import schedframe.resources.computing.Node;
+import schedframe.resources.computing.ComputingResource;
+import schedframe.resources.computing.Processor;
+import schedframe.resources.units.Memory;
+import schedframe.resources.units.ProcessingElements;
+import schedframe.resources.units.ResourceUnit;
+import schedframe.resources.units.ResourceUnitName;
+import schedframe.resources.units.StandardResourceUnitName;
+import schedframe.scheduling.manager.resources.ClusterResourceManager;
+import schedframe.scheduling.manager.resources.ResourceManager;
+import schedframe.scheduling.manager.tasks.JobRegistry;
+import schedframe.scheduling.plan.SchedulingPlanInterface;
+import schedframe.scheduling.plan.impl.SchedulingPlan;
+import schedframe.scheduling.plugin.grid.ModuleList;
+import schedframe.scheduling.queue.TaskQueue;
+import schedframe.scheduling.queue.TaskQueueList;
+import schedframe.scheduling.tasks.TaskInterface;
+
+public class Cluster_FCFSBF_ExamplePlugin extends BaseLocalSchedulingPlugin {
+
+	public SchedulingPlanInterface<?> schedule(SchedulingEvent event, TaskQueueList queues, JobRegistry jobRegistry,
+			ResourceManager resManager, ModuleList modules) {
+
+		ClusterResourceManager resourceManager = (ClusterResourceManager) resManager;
+		SchedulingPlan plan = new SchedulingPlan();
+		// choose the events types to serve.
+		// Different actions for different events are possible.
+		switch (event.getType()) {
+		case START_TASK_EXECUTION:
+		case TASK_FINISHED:
+		//case TIMER:
+			// our tasks are placed only in first queue (see BaseLocalSchedulingPlugin.placeJobsInQueues() method)
+			TaskQueue q = queues.get(0);
+			// check all tasks in queue
+
+			for (int i = 0; i < q.size(); i++) {
+				TaskInterface<?> task = q.get(i);
+				// if status of the tasks in READY
+				if (task.getStatus() == DCWormsTags.READY) {
+					
+					/****************3 ways to schedule task****************/
+					
+					/****************1. Choosing particular resources to perform execution****************/
+					Map<ResourceUnitName, ResourceUnit> choosenResources = chooseResourcesForExecution(resourceManager, task);
+					if (choosenResources != null) {
+						addToSchedulingPlan(plan, task, choosenResources);
+					}
+					
+					/****************2. Choosing resource scheduler/provider to submit the task. If the given resource doesn't contains/isn't 
+					a scheduler, random resources from the given resource will be chosen in order to perform execution****************/
+					/*String provName = chooseProviderForExecution(resourceManager);
+					if (provName != null) {
+						addToSchedulingPlan(plan, task, provName);
+					}*/
+
+					/****************3. Scheduler will choose random resources to perform execution****************/
+					//addToSchedulingPlan(plan, task);
+				}
+			}
+
+			break;
+		}
+		return plan;
+	}
+
+	private Map<ResourceUnitName, ResourceUnit> chooseResourcesForExecution(
+			ClusterResourceManager resourceManager, TaskInterface<?> task) {
+
+		Map<ResourceUnitName, ResourceUnit> map = new HashMap<ResourceUnitName, ResourceUnit>();
+		List<Node> nodes = resourceManager.getNodes();
+		for (Node node : nodes) {
+			int cpuRequest;
+			try {
+				cpuRequest = Double.valueOf(task.getCpuCntRequest()).intValue();
+			} catch (NoSuchFieldException e) {
+				cpuRequest = 0;
+			}
+
+			if (cpuRequest != 0) {
+
+				List<Processor> processors = node.getProcessors();
+				if (processors.size() < cpuRequest) {
+					continue;
+				}
+
+				List<ComputingResource> choosenResources = new ArrayList<ComputingResource>();				
+				for (int i = 0; i < processors.size() && cpuRequest > 0; i++) {
+					if (processors.get(i).getStatus() == ResourceStatus.FREE) {
+						choosenResources.add(processors.get(i));
+						cpuRequest--;
+					}
+				}
+				if (cpuRequest > 0) {
+					continue;
+				}
+
+				ProcessingElements pe = new ProcessingElements();
+				pe.addAll(choosenResources);
+				map.put(StandardResourceUnitName.PE, pe);
+				
+				int memoryRequest;
+				try {
+					memoryRequest = Double.valueOf(task.getMemoryRequest()).intValue();
+				} catch (NoSuchFieldException e) {
+					memoryRequest = 0;
+				}
+				if (memoryRequest != 0) {
+
+					Memory memory = null;
+					try{
+						if (node.getFreeMemory() >= memoryRequest) {		
+							memory = new Memory(node.getMemory(), memoryRequest, memoryRequest);
+						}		
+					} catch(NoSuchFieldException e){
+						continue;
+					}
+					if(memory == null)
+						continue;
+					else {
+						map.put(StandardResourceUnitName.MEMORY, memory);
+						return map;
+					}
+				} else return map;
+			}
+		}
+	
+		return null;
+	}
+
+	@SuppressWarnings("unchecked")
+	private String chooseProviderForExecution(ResourceManager unitsManager) {
+		List<ComputingResource> nodes;
+		Properties properties = new Properties();
+		properties.setProperty("type", StandardResourceType.Node.getName());
+		// properties.setProperty("status", ResourceStatus.FREE.toString());
+		nodes = (List<ComputingResource>) unitsManager.filterResources(properties);
+		
+		//always return the same node from the list
+		return nodes.get(0).getFullName();
+	}
+
+}
Index: DCWoRMS/branches/coolemall/src/example/localplugin/Cluster_FCFSBF_DFSPlugin.java
===================================================================
--- DCWoRMS/branches/coolemall/src/example/localplugin/Cluster_FCFSBF_DFSPlugin.java	(revision 1299)
+++ DCWoRMS/branches/coolemall/src/example/localplugin/Cluster_FCFSBF_DFSPlugin.java	(revision 1299)
@@ -0,0 +1,116 @@
+package example.localplugin;
+
+import gridsim.dcworms.DCWormsTags;
+
+import java.util.ArrayList;
+import java.util.HashMap;
+import java.util.List;
+import java.util.Map;
+
+import schedframe.events.scheduling.SchedulingEvent;
+import schedframe.resources.ResourceStatus;
+import schedframe.resources.computing.ComputingResource;
+import schedframe.resources.computing.Processor;
+import schedframe.resources.units.ProcessingElements;
+import schedframe.resources.units.ResourceUnit;
+import schedframe.resources.units.ResourceUnitName;
+import schedframe.resources.units.StandardResourceUnitName;
+import schedframe.scheduling.manager.resources.ClusterResourceManager;
+import schedframe.scheduling.manager.resources.ResourceManager;
+import schedframe.scheduling.manager.tasks.JobRegistry;
+import schedframe.scheduling.plan.SchedulingPlanInterface;
+import schedframe.scheduling.plan.impl.SchedulingPlan;
+import schedframe.scheduling.plugin.grid.ModuleList;
+import schedframe.scheduling.queue.TaskQueue;
+import schedframe.scheduling.queue.TaskQueueList;
+import schedframe.scheduling.tasks.TaskInterface;
+
+public class Cluster_FCFSBF_DFSPlugin extends BaseLocalSchedulingPlugin {
+
+	public SchedulingPlanInterface<?> schedule(SchedulingEvent event, TaskQueueList queues, JobRegistry jobRegistry,
+			ResourceManager resManager, ModuleList modules) {
+
+		ClusterResourceManager resourceManager = (ClusterResourceManager) resManager;
+		SchedulingPlan plan = new SchedulingPlan();
+		// our tasks are placed only in first queue (see
+		// BaseLocalSchedulingPlugin.placeJobsInQueues() method)
+		TaskQueue q = queues.get(0);
+		// choose the events types to serve.
+		// Different actions for different events are possible.
+		switch (event.getType()) {
+		
+		case START_TASK_EXECUTION:
+		case TASK_FINISHED:
+			// check all tasks in queue
+			for (int i = 0; i < q.size(); i++) {
+				TaskInterface<?> task = q.get(i);
+				// if status of the tasks in READY
+				if (task.getStatus() == DCWormsTags.READY) {
+
+					Map<ResourceUnitName, ResourceUnit> choosenResources = chooseResourcesForExecution(resourceManager, task);
+					if (choosenResources  != null) {
+						addToSchedulingPlan(plan, task, choosenResources);
+					} 
+				}
+			}
+			adjustFrequency(resourceManager.getProcessors());
+		}
+		return plan;
+	}
+	
+	private Map<ResourceUnitName, ResourceUnit> chooseResourcesForExecution(
+			ClusterResourceManager resourceManager, TaskInterface<?> task) {
+
+		Map<ResourceUnitName, ResourceUnit> map = new HashMap<ResourceUnitName, ResourceUnit>();
+
+		int cpuRequest;
+		try {
+			cpuRequest = Double.valueOf(task.getCpuCntRequest()).intValue();
+		} catch (NoSuchFieldException e) {
+			cpuRequest = 0;
+		}
+
+		if (cpuRequest != 0) {
+			List<ComputingResource> choosenResources = null;
+			List<Processor> processors = resourceManager.getProcessors();
+			if (processors.size() < cpuRequest) {
+				// log.warn("Task requires more cpus than is availiable in this resource.");
+				return null;
+			}
+
+			choosenResources = new ArrayList<ComputingResource>();
+
+			for (int i = 0; i < processors.size() && cpuRequest > 0; i++) {
+				if (processors.get(i).getStatus() == ResourceStatus.FREE) {
+					choosenResources.add(processors.get(i));
+					cpuRequest--;
+				}
+			}
+			if (cpuRequest > 0) {
+				// log.info("Task " + task.getJobId() + "_" + task.getId() +
+				// " requires more cpus than is availiable in this moment.");
+				return null;
+			}
+
+			ProcessingElements pe = new ProcessingElements();
+			pe.addAll(choosenResources);
+			map.put(StandardResourceUnitName.PE, pe);
+		}
+		return map;
+	}
+	
+	private void adjustFrequency(List<Processor> processors){
+
+		for(Processor cpu: processors){
+			if(cpu.getStatus() == ResourceStatus.FREE) {
+				if(cpu.getPowerInterface().getSupportedPStates().containsKey("P3"))
+					cpu.getPowerInterface().setPState("P3");
+			}
+			else{
+				if(cpu.getPowerInterface().getSupportedPStates().containsKey("P0"))
+					cpu.getPowerInterface().setPState("P0");
+			}
+		}
+	}
+
+}
Index: DCWoRMS/branches/coolemall/src/example/timeestimation/coolemall/CPUFreqScallingPhaseTimeEstimationPlugin.java
===================================================================
--- DCWoRMS/branches/coolemall/src/example/timeestimation/coolemall/CPUFreqScallingPhaseTimeEstimationPlugin.java	(revision 1299)
+++ DCWoRMS/branches/coolemall/src/example/timeestimation/coolemall/CPUFreqScallingPhaseTimeEstimationPlugin.java	(revision 1299)
@@ -0,0 +1,65 @@
+package example.timeestimation.coolemall;
+
+import java.util.Map;
+
+import org.joda.time.DateTime;
+
+import schedframe.events.scheduling.SchedulingEvent;
+import schedframe.resources.computing.ComputingResource;
+import schedframe.resources.computing.Core;
+import schedframe.resources.computing.Processor;
+import schedframe.resources.units.PEUnit;
+import schedframe.resources.units.ProcessingElements;
+import schedframe.resources.units.ResourceUnit;
+import schedframe.resources.units.ResourceUnitName;
+import schedframe.resources.units.StandardResourceUnitName;
+import schedframe.scheduling.tasks.phases.ResourceConsumption;
+import dcworms.schedframe.scheduling.ExecTask;
+import dcworms.schedframe.scheduling.Executable;
+import example.timeestimation.BaseTimeEstimationPlugin;
+
+public class CPUFreqScallingPhaseTimeEstimationPlugin extends BaseTimeEstimationPlugin{
+
+	
+	public double execTimeEstimation(SchedulingEvent event, ExecTask task,
+			Map<ResourceUnitName, ResourceUnit> allocatedResources,
+			double completionPercentage) {
+		
+		Executable exec = (Executable) task;
+		ResourceConsumption resConsumption = exec.getResourceConsumptionProfile().getCurrentResourceConsumption();
+		String taskFreqString = task.getCurrentResourceConsumption().getReferenceHardware().get("cpu_maxfreq");
+		double taskFreq = Double.valueOf(taskFreqString);
+		
+		PEUnit peUnit = (PEUnit) allocatedResources.get(StandardResourceUnitName.PE);
+		double currentFrequency = 0;
+		
+		if(peUnit instanceof ProcessingElements){
+			ProcessingElements pes = (ProcessingElements) peUnit;
+			for (ComputingResource compResource : pes) {
+				if(compResource instanceof Core) {
+					Core core = (Core) compResource;
+					currentFrequency = core.getProcessor().getPowerInterface().getPState().getFrequency();
+					break;
+				} else if (compResource instanceof Processor) {
+					Processor processor = (Processor) compResource;
+					currentFrequency = processor.getPowerInterface().getPState().getFrequency();
+					break;
+				}
+			}
+		}
+		else 
+			currentFrequency = taskFreq;
+
+		double execTime = (1 - completionPercentage/100) * resConsumption.getDuration() * (taskFreq / currentFrequency);
+
+		// if the result is very close to 0, but less then one millisecond then round this result to 0.001
+		if (Double.compare(execTime, 0.001) < 0) {
+			execTime = 0.001;
+		}
+
+		// time is measured in integer units, so get the nearest execTime int value.
+		execTime = Math.round(execTime);
+		return execTime;
+	}
+
+}
